/*
** AUTHORS:
** Rama Alebouyeh (rama[at]cs.ucsb.edu)
** Matthew S Allen (msa[at]cs.ucsb.edu)
*/
#ifndef _CHIMERA_NETWORK_H_
#define _CHIMERA_NETWORK_H_

#include "host.h"
#include "jrb.h"

#define NETWORK_PACK_SIZE 65536

/** network_address:
 ** returns the ip address of the #hostname#
 */
unsigned long network_address(void * networkglobal, char *hostname);

/** network_init:
 ** initiates the networking layer by creating socket and bind it to #port# 
 */
void * network_init(void *logs, int port);

/**
 ** network_activate: 
 ** NEVER RETURNS. Puts the network layer into listen mode. This thread
 ** manages acknowledgements, delivers incomming messages to the message
 ** handler, and drives the network layer. It should only be called once.
 */
void *network_activate(void * state);

/**
 ** network_send: host, data, size
 ** Sends a message to host, updating the measurement info.
 */
int network_send(void * state, ChimeraHost *host, char *data , int size);

#endif /* _CHIMERA_NETWORK_H_ */
