/*
** AUTHORS:
** Rama Alebouyeh (rama[at]cs.ucsb.edu)
** Matthew S Allen (msa[at]cs.ucsb.edu)
*/
                                                                                

#include <stdio.h>
#include <unistd.h>
#include <stdarg.h>
#include "log.h"

extern FILE *stdin;

/* currently will cause a fail-without-error problem */

void *log_init( ) {
  static FILE **log_fp;
  log_fp = (FILE **) malloc(sizeof(FILE *) * LOG_COUNT);
  memset(log_fp, 0, sizeof(FILE *) * LOG_COUNT);
  return((void *)log_fp);
}

void log_message(void *logs, int type, char *format, ...) {

  va_list ap;
  FILE **log_fp = (FILE **) logs;

  if(log_fp[type] != NULL) {
    va_start(ap, format);
    vfprintf(log_fp[type], format, ap);
  }
}

void log_direct(void *logs, int type, FILE *fp) {

  FILE **log_fp = (FILE **) logs;
  log_fp[type] = fp;
}
